unit Umrechnungen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls;

type
  TLGFT = class(TForm)
    Kartei: TTabControl;
    EditVon: TEdit;
    von: TRadioGroup;
    nach: TRadioGroup;
    EditNach: TEdit;
    procedure VonClick(Sender: TObject);
    procedure KarteiChange(Sender: TObject);
    procedure EditVonKeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  LGFT: TLGFT;

implementation

{$R *.DFM}

 procedure TLGFT.VonClick(Sender: TObject);
  var L:Extended;
  begin
   try
    L:=StrToFloat(EditVon.Text);
   except
    MessageDlg('Fehler bei der Eingabe!'+#13+EditVon.Text,mtError,[mbOk],0);
    exit
   end;
   case Kartei.TabIndex of
     0: begin
         case Von.ItemIndex of
          0 : L:=StrToFloat(EditVon.Text);
          1 : L:=StrToFloat(EditVon.Text)*10;
          2 : L:=StrToFloat(EditVon.Text)*100;
          3 : L:=StrToFloat(EditVon.Text)*1000;
          4 : L:=StrToFloat(EditVon.Text)*1000000;
         end;
         case Nach.ItemIndex of
          0 : EditNach.Text:=FloatToStr(L);
          1 : EditNach.Text:=FloatToStr(L/10);
          2 : EditNach.Text:=FloatToStr(L/100);
          3 : EditNach.Text:=FloatToStr(L/1000);
          4 : EditNach.Text:=FloatToStr(L/1000000);
         end;
        end;
     1: begin
         case Von.ItemIndex of
          0 : L:=StrToFloat(EditVon.Text);
          1 : L:=StrToFloat(EditVon.Text)*1000;
          2 : L:=StrToFloat(EditVon.Text)*1000000;
          3 : L:=StrToFloat(EditVon.Text)*1000000000;
          4 : L:=StrToFloat(EditVon.Text)*1000000000000;
         end;
         case Nach.ItemIndex of
          0 : EditNach.Text:=FloatToStr(L);
          1 : EditNach.Text:=FloatToStr(L/1000);
          2 : EditNach.Text:=FloatToStr(L/1000000);
          3 : EditNach.Text:=FloatToStr(L/1000000000);
          4 : EditNach.Text:=FloatToStr(L/1000000000000);
         end;
        end;
     2: begin
         case Von.ItemIndex of
          0 : L:=StrToFloat(EditVon.Text);
          1 : L:=StrToFloat(EditVon.Text)*100;
          2 : L:=StrToFloat(EditVon.Text)*10000;
          3 : L:=StrToFloat(EditVon.Text)*1000000;
          4 : L:=StrToFloat(EditVon.Text)*1000000000000;
         end;
         case Nach.ItemIndex of
          0 : EditNach.Text:=FloatToStr(L);
          1 : EditNach.Text:=FloatToStr(L/100);
          2 : EditNach.Text:=FloatToStr(L/10000);
          3 : EditNach.Text:=FloatToStr(L/10000000);
          4 : EditNach.Text:=FloatToStr(L/1000000000000);
         end;
        end;
     3: begin
         case Von.ItemIndex of
          0 : L:=Round((StrToFloat(EditVon.Text)-32)/1.8); //Fahrenheit -> Celsius
          1 : L:=Round(StrToFloat(EditVon.Text)/0.8);    // Reaumur -> Celsius
          2 : L:=StrToFloat(EditVon.Text);               // Celsius
          3 : L:=Round(StrToFloat(EditVon.Text)-273);    // Kelvin -> Celsius
         end;
         case Nach.ItemIndex of
          0 : EditNach.Text:=FloatToStr(Round(L*1.8+32));
          1 : EditNach.Text:=FloatToStr(Round(L*0.8));
          2 : EditNach.Text:=FloatToStr(Round(L));
          3 : EditNach.Text:=FloatToStr(Round(L+273));
         end;
        end;
   end
  end;

 procedure TLGFT.KarteiChange(Sender: TObject);
  var K:Byte;
  begin
   with von.Items do
    begin
     Clear;
     case Kartei.TabIndex of
       0: begin
           Add('mm');
           Add('cm');
           Add('dm');
           Add('m');
           Add('km');
          end;
       1: begin
           Add('mg');
           Add('g');
           Add('kg');
           Add('t');
           Add('kt');
          end;
       2: begin
           Add('mm');
           Add('cm');
           Add('dm');
           Add('m');
           Add('km');
          end;
       3: begin
           Add('Fahrenheit');
           Add('Raumur');
           Add('Celsius');
           Add('Kelvin');
          end;
     end;
    end;
   Nach.Items.Clear;
   for K:=0 to Von.Items.Count-1 do
    Nach.Items.Add(Von.Items[K]);
   Von.ItemIndex:=0;Nach.ItemIndex:=0;
   EditNach.Text:=''; 
  end;

 procedure TLGFT.EditVonKeyPress(Sender: TObject; var Key: Char);
  begin
   if Key='.' then Key:=','; // Punkt in Komma umwandeln
   // alle nicht zulssigen Zeichen werden ignoriert
   if not(Key in['0'..'9','+','-',',',#8,#13]) then Key:=#0
   else if Key=#13 then VonClick(Sender);
   // bei <Enter> wird VonClick ausgefhrt
  end;

end.

